//  autodetect.h
//
//  field / interlace auto detection
//
//	Copyright (c) 2005 N099
//
#ifndef __AUTODETECT_H__
#define __AUTODETECT_H__

// image format struct for auto detection
struct AD_IMGDATA
{
	int format; // defined in hwdeintdefs.h
	int w; // in pixel
	int h; // in pixel
	int sw; // in pixel
	int samples; //effective samples in a pixel
	int bpp; // byte per pixel (w/ alpha ch)
};

//field order detection
int detect_order(const AD_IMGDATA *, unsigned char *, unsigned char *);
int detect_order_isse(const AD_IMGDATA *, unsigned char *, unsigned char *);

//interlace detection
int detect_i(const AD_IMGDATA *, unsigned char *, unsigned char *);
int detect_i_isse(const AD_IMGDATA *, unsigned char *, unsigned char *);

//field order + interlace detection
int detect_both(const AD_IMGDATA *, unsigned char *, unsigned char *);
int detect_both_isse(const AD_IMGDATA *, unsigned char *, unsigned char *);

//sse detection
int is_sse_usable(void);

//for visualize
void visualize_order(const AD_IMGDATA *, unsigned char *, int, int ,int);
void visualize_i(const AD_IMGDATA *, unsigned char *, int);
void visualize_both(const AD_IMGDATA *, unsigned char *, int);

#endif